;*************************************************************************
; FILE ..........: SPEED400.ASM
; AUTHOR ........: Vitaly Puzrin
; DESCRIPTION ...: ணࠬ ஫ ॣ ᪮
;		    ⥫ Speed400
; NOTES .........:
; COPYRIGHT .....: Vitaly Puzrin, 1998
; HISTORY .......: DATE		COMMENT
;                  ---------------------------------------------------
;*************************************************************************

		PROCESSOR	PIC12C509
                INCLUDE		<P12C509.inc>
		radix		dec

                __config  _MCLRE_OFF & _CP_ON & _WDT_ON & _IntRC_OSC

; 祭 ࠧ冷  GPIO,  ࠢ  뢮 (ॣ TRIS)
;StartBtnBit	EQU	1               ; 室  "Quick Start"
StopBit         EQU       1               ; Turns on brake
RunBit          EQU	2               ; 室 祭 
ServoBit        EQU	0               ; 室 ࠢ ᮢ
BattOkBit       EQU	3               ; 室  

TrisBits        EQU       H'FF' & ~((1 << StopBit) | (1 << RunBit))


; Bits to be set with the OPTION instruction
;  No wake up
;  Weak pull-up enabled
;  Timer 0 source internal
;  Which edge is don't care
;  Prescaler to watchdog, set to give 16*17 ms timeout
;
OptionBits	EQU	B'10011100'

; ==========================================================================
; ⠭ ࠡ祣 ⬠
;
PWM_Period	EQU	47		; ⢮ 横  7 権
PWM_Start	EQU	4		; Lowest cycle count
InvalidPulseBit	EQU	7		; 0x80
BrakeEnableBit	EQU	6		; 0x40
ArmPulsesReqd	EQU	5		; consecutive in-range pulses

; ==========================================================================
; ⮢ 䫠
;
BattLow         EQU	0
PriorServoBit   EQU	1
;
; ६
;
Flags		EQU	8			; 祩  ⮢묨 䫠
PwmCount	EQU	Flags + 1		; 稪 ࠡ⠭
						; ⥫쭮  -
PwmWidth	EQU	PwmCount + 1		;  -
ServoCount	EQU	PwmWidth + 1		; ⨪ ⥫쭮
						; ࠢ饣 
						; (訩 )
Command		EQU	ServoCount + 1		;  , ⢥饩
						; ﭭ ⥫쭮
						; ࠢ饣 㬯
ArmPulseCount	EQU	Command + 1		; 稪 "ଠ"
						; ᮢ, 室 
						; 祭 ॣ
;ServoCountHi	EQU	ArmPulseCount + 1	; ⨪ ⥫쭮
						; ࠢ饣 
						; (訩 )
;Tmp		EQU	ServoCountHi + 1	; ६ ६

; =========================================================================
;   樨 ப   "NOP"
;
NO_OP		MACRO	count
NO_OP_COUNT	SET	count
		WHILE	NO_OP_COUNT
		nop
NO_OP_COUNT	SET	NO_OP_COUNT - 1
		ENDW
		ENDM

; =========================================================================
;   ⠭  砫쭮 ﭨ ࠭୮ .
;  室, W ᮤন 稪 ⥫쭮
;
DoRunBit	MACRO				; 5 
		movf	PwmWidth, W
		skpz
		bsf	GPIO, RunBit
		skpnz
		bcf	GPIO, RunBit
		ENDM

; =========================================================================
;   ७ 쭮 ࠢ饣 
;
DoServoCount	MACRO				; 2 
		btfsc	GPIO, ServoBit
		incf	ServoCount, F
		ENDM


; =========================================================================
; =========================================================================
; ⢥, ᠬ .

Coldstart:	ORG	0

		movwf	OSCCAL		; 㧨 㢮 ⠭
		bcf	STATUS, PA0	;  ᭮,   ࢮ ࠭
;
;  ᫥⥫쭮  .  ४砥 ।⥫
;  TMR0  WDT, ᪫ 砩  ப஫
;
		clrwdt
		clrf	TMR0
		movlw	OptionBits | 7
		option
		clrwdt
		movlw	OptionBits
		option
		clrwdt

		clrf	GPIO			; ࠨ  /
		movlw	TrisBits
		tris	GPIO			;  室 -  0

; =========================================================================
; (!) .       祭 ⠭,  
;  殮  ॥.   砥, ⥫  
; 몫祭.
;
Rearm:		clrwdt
		btfss	GPIO, BattOkBit
		goto	Rearm
;
; 砫 㦭  砫 ࠢ饣 
; (   ஢ 稥 ࢨ쭮 ᨣ)
;
RaLoop1:	btfss	GPIO, BattOkBit
		goto	Rearm
		btfss	GPIO, ServoBit
		goto	RaLoop1
RaLoop2:	btfss	GPIO, BattOkBit
		goto	Rearm
		btfsc	GPIO, ServoBit
		goto	RaLoop2
		clrf	ServoCount
		clrwdt
		movlw	ArmPulsesReqd
		movwf	ArmPulseCount
;
; , 塞 ⥫쭮   ࠡ뢠 
;
RaLoop3:	btfss	GPIO, BattOkBit
		goto	Rearm
		btfss	GPIO, ServoBit
		goto	RaLoop3

RaLoop4:	incf	ServoCount, F
		btfss	GPIO, BattOkBit
		goto	Rearm
		NO_OP	1
		btfsc	GPIO, ServoBit
		goto	RaLoop4			;  横   7 
		clrwdt
		movf	ServoCount, W
		call	ServoLookup
		bcf	STATUS, PA0		; ⠭ ࠡ稩
						;  
;   ⮫쪮  ,  ਢ
;  ⠭ ⥫ ( )
		clrf	ServoCount
		andlw	1 << BrakeEnableBit
		skpnz
		goto	RaLoop1

		decfsz	ArmPulseCount,F		; 諮  筮
						; ⢮ "ࠢ"
						; ᮢ ?
		goto	RaLoop3

		clrf	PwmWidth		;  몫祭
		clrf	Flags			;  뢠  䫠

PreMainPwmLoop:
		NO_OP	1
; ===========================================================
; ᭮ 横 ନ஢ -
;
MainPwmLoop:
		DoServoCount			; 4th Precycle
		NO_OP	1
;  ᪫祭 ᫥ , 横 ⠢ 24 ⠪
PwmEntry1:
		call	DoPwmPulse
		DoServoCount			;
		DoRunBit
		DoServoCount			; 1st Precycle
		movwf	PwmCount		; From DoRunBIt
		btfsc	GPIO, ServoBit
		goto	ServoIsHigh
		btfsc	Flags, PriorServoBit
		goto	EndOfPulse
		DoServoCount			; 2nd Precycle
MainPwmEntry:
		nop
		btfsc	Flags, BattLow		; Sneak this in here
		goto	BattLoShutdown
		goto	MainPwmLoop
ServoIsHigh:
		bsf	Flags, PriorServoBit
		nop
		DoServoCount			; 3rd Precycle, different path
		nop
		btfsc	Flags, BattLow		; Sneak this in here
		goto	BattLoShutdown		; If batt was ever low, quit now
		goto	MainPwmLoop

; ============================================================================
; ᭮ ᫥⥫쭮 ⢨:
;   DoPwmPulse
;    2*nop
;   DoRunBit  ࠭ १
;    17*nop
;   DoPwmPulse    ..
;
;   ࠡ  ⥬ 
;  NOP  室 樨
;
EndOfPulse:
		bcf	Flags, PriorServoBit
		clrwdt
		NO_OP	7
		call	DoPwmPulse
		NO_OP	2
;
		DoRunBit
		movwf	PwmCount
		movf	ServoCount, W
		call	ServoLookup		; 7 clocks
		movwf	Command
		movwf	PwmCount
		clrf	ServoCount
		bcf	STATUS, PA0
		NO_OP	4
		call	DoPwmPulse
		NO_OP	2
;
		DoRunBit			; (!) ᯮ ࠬ
						; ।饩 
		movwf	PwmCount
		NO_OP	5
		btfsc	Command, InvalidPulseBit
		goto	MainPwmEntry
;
 		movf	Command,W
		andlw	H'3F'			; 塞   ମ
		movwf	PwmWidth

		btfss	Command, BrakeEnableBit
		goto	RunningCommand
;
		NO_OP	4
		call	DoPwmPulse
		bsf	GPIO, StopBit		; 砥 ମ
		NO_OP	1
		DoRunBit
		NO_OP	7
		goto	MainPwmEntry

RunningCommand:
		bcf	GPIO, StopBit		; 몫砥 ମ ( 
						;  㦥 몫祭)
		goto	PwmEntry1		; (!)   㤥 ய饭.
						; ⥫ , 稭
						;  ᫥饣


; ==========================================================================
;  ᥫ - ⠭ 
;  室  騩 ०
;
BattLoShutdown:
		bcf	GPIO, RunBit
; WARNING - DON'T DIDDLE THE GPIO REGISTER until the RunBit settles.
; You may end up leaving it set!
		call	DoPwmPulse		; For delay only
		bsf	GPIO, StopBit		; 砥 ମ
		nop
		goto	Rearm

; ==========================================================================
; ८ࠧ ⥫쭮   . 頥   W
; (!)  饭 PA0  ⠭  1.
; PC = (PA0 << 9) | (0 << 8) | W.
; ,  ன 頥,   䠩 speed400.inc
;
ServoLookup:
		bsf	STATUS, PA0
		movwf	PCL

; ==========================================================================
; 㭪 樨 1  -.  맮,    祭
;  몫祭. ᫨ 몫祭,   㤥 祭.  ᫨  ࠡ⠫,
;  몫  ⮫쪮 稪 PWM_Count 㫨.
;
DoPwmPulse:
PWM_LOOP_COUNT	SET	PWM_Period - PWM_Start
		WHILE	PWM_LOOP_COUNT

		btfss	GPIO, BattOkBit
		bsf	Flags, BattLow
		DoServoCount			; 2 
		decf	PwmCount,F
		skpnz
		bcf	GPIO, RunBit

PWM_LOOP_COUNT	SET	PWM_LOOP_COUNT - 1
		ENDW

		retlw	0

; ==========================================================================
;  ८ࠧ ⥫쭮   .
;  - 0..255,  ।⠢ ᮡ 訥 8  ⥫쭮
; , ﭭ  7- 蠣.
;  室:
;   PWM_width | ((invalid width)? 0x80 : 0) | ((Brake width range)? 0x40 : 0)
; PWM_width 室    0  63,  0 砥
; 몫祭 ⥫
;
                ORG       H'200'          ; Low part of second page (PA0==1)
                INCLUDE   "speed400.inc"  ;

                END

